/*
 * vLog.h
 *
 *  Created on: Feb 2, 2017
 *      Author: vagner
 */

#pragma once

#include <mutex>
#include <string>

#define gLog	vLog::gv->Log
#define gLogf	vLog::gv->Logf
#define gShow	vLog::gv->Show

namespace vCommon
{
	//	типы сообщений в журнале
	enum class LMT
	{
		Inf = 1,//	информация
		Wrn,	//	предупреждение
		Err,	//	ошибка
		Dbg		//	отладочное
	};
	//
	//	Журналист
	//
	class vLog
	{
	private:
		//	семафор журналиста
		std::mutex mtLog;
		std::mutex mtShow;
		/// имя файла журнала.
		std::string FileName;
		//	вербальное представление типа сообщения
		std::string mtString ( LMT mt );
		//	создать сообщение журнала
		std::string msgFormat ( LMT mt, const std::string Message );

	public:
		//	глобальный журнал
		static vLog* gv;
		static const size_t MaxMessageSize = 4096;
        //  размер файла журнала
        int LogSize;
        //  флаг журналирования отладочной информации
        bool IsDebug;
        //  флаг дублирования журнала на консоль
        bool IsConsole;
		//	ctor
		vLog ( const std::string& Path, const std::string& LogFileName, int LogSize
			, bool IsDebug = false, bool IsConsole = false );
#ifdef __KOS__
		~vLog ( );
#endif
		// Залогировать сообщение.
		void Log ( LMT mt, const std::string& Message );
		void Logf ( LMT mt, const std::string& Format, ... );
		/// Показать простое сообщение.
		void Show ( LMT mt, const std::string& Message );
		void Showf ( LMT mt, const std::string& Format, ... );

		//	печать hex
		void PrintHex ( const void* buf, const int bsize, const std::string& Title );
	};

} /* namespace vCommon */
