/*
 * vString.h
 *
 *  Created on: Jan 31, 2017
 *      Author: vagner
 */

#pragma once

#include <string>
#include <vector>

namespace vCommon
{
	class vString
	{
	public:
		//
		//	true - если src_str заканчивается на end_str
		//
		static bool EndsWith ( const std::string& src_str, const std::string& end_str );
		//
		//	true - если если все символы str, это символы из symbols
		//
		static bool IsOneOf ( const std::string& str, const std::string& symbols );
        static bool IsOneOf_0 ( const char c, const std::string& symbols );
		//
		//	IsSpace
		//
		static bool IsSpace ( const char c );
		//
		//	Format
		//
		static std::string Format ( const std::string& FormatString, ... );
		//
		//	Replace
		//
		static std::string Replace ( const std::string& src, const std::string& search, const std::string& rep );
		//
		//	Split
		//
		static std::vector <std::string> Split ( const std::string& str, const std::string& delimiter );
		//
		//	true - если src_str начинается с start_str
		//
		static bool StartsWith ( const std::string& src_str, const std::string& start_str );
        //
        //  Создать строку из указателя и размера.
        //
		static std::string StringFromPtr ( const int size, const char* ptr );
		//
		//  Создать строку из указателя и освободить указатель.
		//
		static std::string StringFromPtr ( const char* ptr, bool IsFreePtr = true );
		//
		//	ToLower
		//
		static std::string ToLower ( const std::string& str );
		//
		//	Trim
		//
		static std::string Trim ( const std::string& str );
	};

} /* namespace vCommon */
