//
//	mqSyncClient.h
//	Автор	:	vagner
//	Создан	:	Sep 25, 2019
//

#pragma once

#include <string>
#include <vector>

#include <vCommon.h>

#include "mqClient.h"

namespace vMQ
{
	//	Синхронный клиент MQTT
	//	Синхронный клиент будет работать через асинхронного,
	//	скрывая от пользователя асинхронность.
	class mqSyncClient
	{
	public:

		//	асинхронный клиент (АК)
		mqClient *mqc;

		//	очередь сообщений АК
		vCommon::SyncVector *sv;

		//	IsConnected
		inline bool IsConnected ( )
		{
			return ( mqc != nullptr ) && ( mqc->getBool ( mqc->IsConnected ) );
		}

		//	ctor
		mqSyncClient ( const std::string& ClientId );

		//	dtor
		virtual ~mqSyncClient ( );

		//	установить соединение
		//	sTO - таймаут в секундах
		bool connect ( const std::string& Url, int Port, int sTO );

		//	опубликовать
		bool publish ( const std::string& Topic, const std::string& Payload, int qos, bool retain );

		//	подписаться
		bool subscribe ( const std::vector <subsItem> &SubsList );

		//	получить сообщение
		//	sTO - таймаут в секундах
		mqMsg* GetMessage ( int sTO );
	};

} /* namespace vMQ */
