//
//	ServerTime.h
//
//	Автор	:	vagner
//	Создан	:	Sep 30, 2019
//

#pragma once

#include <string>

#include <vCommon.h>
#include <vtime.h>

namespace vtc
{
#ifdef __KOS__
	static const std::string stFileName ( "/opt/sem-next/example/var/inspark/server_time" );
#else
	#ifdef VAGNER
		static const std::string stFileName ( "/home/vagner/sem/var/inspark/server_time" );
	#else
		static const std::string stFileName ( "/var/inspark/server_time" );
	#endif
#endif

	class ServerTime
	{
	public:

		//	смещение относительно монотонного времени
		i64 u_offset;

		//	часовой пояс
		i32 t_zone;

		//	время сервера на момент синхронизации
		i64 server_time;

		//	локальное время
		i64 local_time;

		//	идентификатор команды сервера
		std::string command_id;

		//	идентификатор клиента
		std::string FileName;

		//	ctor
		ServerTime ( const std::string& ClientId );

		//	рапарсить ответ от сервера
		bool parse_command ( std::string& cmd );

		//	Загрузить состояние объекта из файла.
		bool Load  ( );

		//	Сохранить состояние объекта в файл.
		bool Save ( );
	};

} /* namespace vtc */
